using System;
using System.Collections;
using System.Xml;

namespace stunnware.CRM.Fetch {
   /// <summary>
   /// Summary description for CrmEntityCollection.
   /// </summary>
   public class CrmEntityCollection {

      private XmlDocument _resultXmlDoc;
      private CrmEntity[] _entities;
       
      public CrmEntityCollection(string responseXml) {

         _resultXmlDoc = new XmlDocument();
         _resultXmlDoc.LoadXml(responseXml);

         XmlNodeList entityNodes = _resultXmlDoc.SelectNodes("resultset/result");
         _entities = new CrmEntity[entityNodes.Count];

         int index = 0;

         foreach(XmlNode entityNode in entityNodes) {
            _entities[index++] = new CrmEntity(entityNode);
         }            
      }

      public string PagingCookie {
         get {
            XmlAttribute attr = _resultXmlDoc.Attributes["paging-cookie"];
            return (attr == null) ? null : attr.Value;
         }
      }

      public bool MoreRecords {
         get {
            XmlAttribute attr = _resultXmlDoc.Attributes["morerecords"];
            return (attr == null) ? false : (attr.Value == "1");
         }
      }

      public string Xml {
         get {
            return _resultXmlDoc.OuterXml;
         }
      }

      public int Count {
         get {
            return _entities.Length;
         }
      }

      public CrmEntity this[int index] {
         get {
            return _entities[index];
         }
      }
      
      public IEnumerator GetEnumerator() {
         return _entities.GetEnumerator();
      }
   }
}